<?php
/**
 * @entity SOYMock_Sample
 * 
 * 使い方
 * $dao = SOY2DAOFactory::create("SOYMock_SampleDAO");
 * $array = $dao->get();
 */
abstract class SOYMock_SampleDAO extends SOY2DAO{

	/**
	 * @return id
	 * @trigger onInsert
	 */
	abstract function insert(SOYMock_Sample $bean);
	
	/**
	 * @trigger onUpdate
	 */
	abstract function update(SOYMock_Sample $bean);
	
	/**
	 * @return list
	 * @order id desc
	 */
	abstract function get();
	
	abstract function deleteById($id);
	
	/**
	 * @return object
	 */
	abstract function getById($id);
	
	/**
	 * @return object
	 */
	abstract function getByName($name);
	
	/**
	 * @return object
	 * @query create_date > :createDate AND update_date > : updateDate
	 * @order id desc
	 */
	abstract function getByCreateDateAndUpdateDate($createDate, $updateDate);
	
	/**
	 * @return column_count
	 * @columns count(id) as count
	 */
	abstract function count();
	
	function getObject(){
		$name = "";
		
		$dao = new SOY2DAO();
		
		$sql = "SELECT * FROM soymock_sample WHERE name LIKE %%:name%%";
		$binds = array(":name" => $name);
		
		try{
			$objects = $dao->executeQuery($sql, $binds);
		}catch(Exception $e){
			$objects = array();
		}
		
		return $objects;
	}

	/**
	 * @final
	 */
	function onInsert($query, $binds){
		$binds[":createDate"] = time();
		$binds[":updateDate"] = time();
		
		return array($query, $binds);
	}
	
	/**
	 * @final
	 */
	function onUpdate($query, $binds){
		$binds[":updateDate"] = time();
		return array($query, $binds);
	}
}
?>